import LngLat, { LngLatLike } from '../geo/lng_lat';
export declare function mercatorXfromLng(lng: number): number;
export declare function mercatorYfromLat(lat: number): number;
export declare function mercatorZfromAltitude(altitude: number, lat: number): number;
export declare function lngFromMercatorX(x: number): number;
export declare function latFromMercatorY(y: number): number;
export declare function altitudeFromMercatorZ(z: number, y: number): number;
/**
 * Determine the Mercator scale factor for a given latitude, see
 * https://en.wikipedia.org/wiki/Mercator_projection#Scale_factor
 *
 * At the equator the scale factor will be 1, which increases at higher latitudes.
 *
 * @param {number} lat Latitude
 * @returns {number} scale factor
 * @private
 */
export declare function mercatorScale(lat: number): number;
export default class MercatorCoordinate {
    static fromLngLat(lngLatLike: LngLatLike, altitude?: number): MercatorCoordinate;
    x: number;
    y: number;
    z: number;
    constructor(x: number, y: number, z?: number);
    toLngLat(): LngLat;
    toAltitude(): number;
    meterInMercatorCoordinateUnits(): number;
}
