import { EarthMap } from '../earthmap';
import { Map } from '../map';
/**
 * The `KeyboardHandler` allows the user to zoom, rotate, and pan the map using
 * the following keyboard shortcuts:
 *
 * - `=` / `+`: Increase the zoom level by 1.
 * - `Shift-=` / `Shift-+`: Increase the zoom level by 2.
 * - `-`: Decrease the zoom level by 1.
 * - `Shift--`: Decrease the zoom level by 2.
 * - Arrow keys: Pan by 100 pixels.
 * - `Shift+⇢`: Increase the rotation by 15 degrees.
 * - `Shift+⇠`: Decrease the rotation by 15 degrees.
 * - `Shift+⇡`: Increase the pitch by 10 degrees.
 * - `Shift+⇣`: Decrease the pitch by 10 degrees.
 */
declare class KeyboardHandler {
    private enabled;
    private active;
    private panStep;
    private bearingStep;
    private pitchStep;
    /**
     * @private
     */
    constructor();
    reset(): void;
    keydown(e: KeyboardEvent): {
        cameraAnimation: (map: Map | EarthMap) => void;
    } | undefined;
    enable(): void;
    disable(): void;
    isEnabled(): boolean;
    isActive(): boolean;
}
export default KeyboardHandler;
