"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _l7Utils = require("@antv/l7-utils");

var DragPanHandler = function () {
  function DragPanHandler(el, mousePan, touchPan) {
    (0, _classCallCheck2.default)(this, DragPanHandler);
    (0, _defineProperty2.default)(this, "inertiaOptions", void 0);
    (0, _defineProperty2.default)(this, "el", void 0);
    (0, _defineProperty2.default)(this, "mousePan", void 0);
    (0, _defineProperty2.default)(this, "touchPan", void 0);
    this.el = el;
    this.mousePan = mousePan;
    this.touchPan = touchPan;
  }

  (0, _createClass2.default)(DragPanHandler, [{
    key: "enable",
    value: function enable(options) {
      this.inertiaOptions = options || {};
      this.mousePan.enable();
      this.touchPan.enable();

      if (!_l7Utils.isMini) {
        this.el.classList.add('l7-touch-drag-pan');
      }
    }
  }, {
    key: "disable",
    value: function disable() {
      this.mousePan.disable();
      this.touchPan.disable();

      if (!_l7Utils.isMini) {
        this.el.classList.remove('l7-touch-drag-pan');
      }
    }
  }, {
    key: "isEnabled",
    value: function isEnabled() {
      return this.mousePan.isEnabled() && this.touchPan.isEnabled();
    }
  }, {
    key: "isActive",
    value: function isActive() {
      return this.mousePan.isActive() || this.touchPan.isActive();
    }
  }]);
  return DragPanHandler;
}();

exports.default = DragPanHandler;
//# sourceMappingURL=drag_pan.js.map